﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using Infragistics.Windows.DataPresenter;
using Infragistics.Windows.DataPresenter.Events;
using System.ComponentModel;
using Infragistics.Windows.Controls;

namespace Grouping
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        /// <summary>
        ///  Contains List of Person
        /// </summary>
        private List<PersonDetails> _personInfoList;

        /// <summary>
        /// Contains person entity
        /// </summary>
        private PersonDetails _personInfoEntity;

        public Window1()
        {
            InitializeComponent();
            this.Loaded += new RoutedEventHandler(Window1_Loaded);
            this.grdSearchList.InitializeRecord += new EventHandler<Infragistics.Windows.DataPresenter.Events.InitializeRecordEventArgs>(grdSearchList_InitializeRecord);
            grdSearchList.Grouping += new EventHandler<GroupingEventArgs>(grdSearchList_Grouping);
        }

        void grdSearchList_Grouping(object sender, GroupingEventArgs e)
        {
            try
            {
                //FilterData filterData = null;

                if (e.Groups != null && e.Groups.Length > 0)
                {
                    if (e.Groups.Length == 1)
                        ModifyGroupByType(e.Groups, grdSearchList);
                    else
                    {
                        //var group = e.Groups.Where(n => n.IsSealed == false);
                        //if (group != null && group.Count() > 0)
                        //{
                        //    filterData = new FilterData();
                        //    filterData.ColumnName = group.ToArray()[0].FieldName;
                        //    filterData.TagValue = "GroupBy";

                        //    GroupField(filterData);

                        //    e.Cancel = true;
                        //}
                    }
                }
            }
            catch { }
        }

        private void ModifyGroupByType(FieldSortDescription[] groups, XamDataGrid grdSearchList)
        {
            for (int i = 0; i <= groups.Length - 1; i++)
            {
                FieldSortDescription sortDesc = groups[i];
                try
                {
                    if (grdSearchList.FieldLayouts[0].Fields[groups[i].FieldName].SortStatus == SortStatus.Ascending || grdSearchList.FieldLayouts[0].Fields[groups[i].FieldName].SortStatus == SortStatus.NotSorted)
                    {

                        if (sortDesc.FieldName == "DateModified" | sortDesc.FieldName == "DateCreated" | sortDesc.FieldName == "ExpiryDate")
                            sortDesc.Direction = ListSortDirection.Descending;
                        else
                            sortDesc.Direction = ListSortDirection.Ascending;

                    }
                    else
                        sortDesc.Direction = ListSortDirection.Descending;
                }
                catch { }

                switch (sortDesc.FieldName)
                {
                    case "Name":
                    case "DisplayName":
                    case "Address":
                        grdSearchList.FieldLayouts[0].Fields[sortDesc.FieldName].Settings.GroupByEvaluator = new FileNameGroupEvaluator();
                        break;
                    case "Size":
                        //grdSearchList.FieldLayouts[0].Fields[sortDesc.FieldName].Settings.GroupByEvaluator = new FileSizeGroupEvaluator();
                        break;
                    case "FileID":
                       // grdSearchList.FieldLayouts[0].Fields[sortDesc.FieldName].Settings.GroupByEvaluator = new FileIDGroupEvaluator();
                        break;
                    default:
                        break;
                }
            }
        }


        void grdSearchList_InitializeRecord(object sender, Infragistics.Windows.DataPresenter.Events.InitializeRecordEventArgs e)
        {
            ModifyGroupByText(ref e);
        }

        void Window1_Loaded(object sender, RoutedEventArgs e)
        {
            this.GetPersonList();
        }


        public static void ModifyGroupByText(ref InitializeRecordEventArgs e)
        {
            try
            {
                if (e.Record != null && e.Record.RecordType == RecordType.GroupByField && e.Record.ViewableChildRecords != null && e.Record.ViewableChildRecords.Count > 0)
                {
                    GroupByRecord grpByRecord = e.Record as GroupByRecord;
                    if (grpByRecord == null) return;
                    string grpBy = grpByRecord.GroupByField.Name;

                    if (grpBy == "FileID" | grpBy == "Size" | grpBy == "Name" | grpBy == "ContactNo" | grpBy == "Address" )
                    {
                        DataRecord firstRecord = null;
                        if (e.Record.ViewableChildRecords[0] is GroupByRecord)
                        {
                            firstRecord = GetDataRecord(e.Record.ViewableChildRecords[0] as GroupByRecord);
                        }
                        else
                            firstRecord = (DataRecord)e.Record.ViewableChildRecords[0];

                        if (firstRecord == null) return;
                        string publish = string.Empty, type = string.Empty, discussion = string.Empty, storageCategory = string.Empty;

                        //if (firstRecord.DataItem is DocumentSearchResult)
                        //{
                        //    DocumentSearchResult result11 = (DocumentSearchResult)firstRecord.DataItem;
                        //    statusImage = result11.StatusImage;
                        //    publish = result11.Publish;
                        //    type = result11.Type;
                        //    discussion = result11.FileDiscussion;
                        //    storageCategory = result11.StorageCategory;
                        //}
                        //else
                        //{
                        //    var v = (DocumentEntity)firstRecord.DataItem;
                        //    statusImage = v.FileStatusImage;
                        //    publish = (v.PublishedFlag) ? "Y" : "N";
                        //    type = v.Type;
                        //    discussion = v.FileDiscussion;
                        //    storageCategory = v.StorageCategory;

                        //}
                        string statusImage = string.Empty;
                        string count = string.Empty;
                        if (e.Record.ViewableChildRecords.Count > 1)
                            count = " (" + e.Record.ViewableChildRecords.Count + " items)";
                        else
                            count = " (" + e.Record.ViewableChildRecords.Count + " item)";
                    }
                }
            }
            catch { }
        }

        private static DataRecord GetDataRecord(GroupByRecord groupRecord)
        {
            if (groupRecord == null || groupRecord.ViewableChildRecords.Count <= 0) return null;

            if (groupRecord.ViewableChildRecords[0] is GroupByRecord)
                return GetDataRecord(groupRecord.ViewableChildRecords[0] as GroupByRecord);
            else if (groupRecord.ViewableChildRecords[0] is DataRecord)
                return groupRecord.ViewableChildRecords[0] as DataRecord;
            else
                return null;
        }

        private void GetPersonList()
        {
            this._personInfoList = new List<PersonDetails>();
            try
            {
                this._personInfoEntity = new PersonDetails("karthickraja S", 30, "M", "13 Ramnagar, P&T Nagar via, vagaikullam post, Madurai -17", "9751300562", 5, "A12");
                this._personInfoList.Add(this._personInfoEntity);

                this._personInfoEntity = new PersonDetails("karthic", 17, "M", "P&T Nagar via, vagaikullam post, Madurai -17", "45413005242", 4, "A32");
                this._personInfoList.Add(this._personInfoEntity);

                this._personInfoEntity = new PersonDetails("karthic", 27, "M", "P&T Nagar via,Madurai -17", "7853005242", 24, "A33");
                this._personInfoList.Add(this._personInfoEntity);

                this._personInfoEntity = new PersonDetails("karthic", 29, "M", "Bangalow street,Thiruppuvanam, Sivagangai Dist -17", "9994523696", 15, "A33");
                this._personInfoList.Add(this._personInfoEntity);

                this._personInfoEntity = new PersonDetails("Saravana M", 25, "M", "9 A karuppana pillai street Madurai", "9945246253", 28, "A33");
                this._personInfoList.Add(this._personInfoEntity);

                this._personInfoEntity = new PersonDetails("Shankar s", 25, "M", "Cbe", "9791304529", 03, "A32");
                this._personInfoList.Add(this._personInfoEntity);

                this._personInfoEntity = new PersonDetails("karthic", 23, "M", "9 A karuppana pillai street Madurai", "9994553696", 10, "A12");
                this._personInfoList.Add(this._personInfoEntity);

                this._personInfoEntity = new PersonDetails("Aruna  M", 20, "F", "A karuppana pillai street Madurai", "9994623696", 19, "A44");
                this._personInfoList.Add(this._personInfoEntity);

                this._personInfoEntity = new PersonDetails("Aruna  M", 20, "F", "9 karuppana pillai street Madurai", "9994623696", 16, "A12");
                this._personInfoList.Add(this._personInfoEntity);

                this._personInfoEntity = new PersonDetails("Aruna  XM", 20, "F", "10 A karuppana pillai street Madurai", "9994623696", 18, "A44");
                this._personInfoList.Add(this._personInfoEntity);
            }
            catch
            {
            }
            this.grdSearchList.DataSource = this._personInfoList;
        }
    }

    public class FileNameGroupEvaluator : IGroupByEvaluator
    {
        public bool DoesGroupContainRecord(GroupByRecord groupByRecord, DataRecord record)
        {
            object cellValue = record.GetCellValue(groupByRecord.GroupByField);
            string desc = groupByRecord.Description;

            // handle null values speciallyl
            if (string.IsNullOrEmpty(desc))
                desc = "None";

            // if the value is not a date time, just group them together
            if (cellValue is string == false)
                return true;

            if ((desc.EndsWith(" items)") | desc.EndsWith(" item)")) && desc.LastIndexOf('(') != -1)
                desc = desc.Remove(desc.LastIndexOf('(')).Trim();

            return desc == GetGroupByText(Convert.ToString(cellValue));
        }

        public object GetGroupByValue(GroupByRecord groupByRecord, DataRecord record)
        {
            object cellValue = record.GetCellValue(groupByRecord.GroupByField);
            string desc = string.Empty;
            string fileName = Convert.ToString(cellValue);

            if (string.IsNullOrEmpty(fileName))
                desc = "None";
            else
            {
                if ("abcdefgh".Contains(fileName.Substring(0, 1).ToLower()))
                    desc = "A - H";
                else if ("ijklmnop".Contains(fileName.Substring(0, 1).ToLower()))
                    desc = "I - P";
                else if ("qrstuvwxyz".Contains(fileName.Substring(0, 1).ToLower()))
                    desc = "Q - Z";
                else
                    desc = "0 - 9";
            }
            groupByRecord.Description = desc;
            return desc;
        }

        public System.Collections.IComparer SortComparer
        {
            // return null to use the default comparer
            get { return null; }
        }

        private string GetGroupByText(string fileName)
        {
            string desc;
            if (string.IsNullOrEmpty(fileName))
                desc = "None";
            else if ("abcdefgh".Contains(fileName.Substring(0, 1).ToLower()))
                desc = "A - H";
            else if ("ijklmnop".Contains(fileName.Substring(0, 1).ToLower()))
                desc = "I - P";
            else if ("qrstuvwxyz".Contains(fileName.Substring(0, 1).ToLower()))
                desc = "Q - Z";
            else
                desc = "0 - 9";

            return desc;
        }
    }
}
